import peasy.*;

PeasyCam cam;

PVector pRay = new PVector(50, 50, 0);
PVector pRayDir = new PVector(0.8, .7, 1);

PVector boxCenter = new PVector(0, 60, 100);
float   boxW = 200;
float   boxH = 100;
float   boxD = 80;

PMatrix3D xform = new PMatrix3D();

PickHelpers pickHelpers = new PickHelpers();


void setup()
{
  // set the window size + 3d mode
  size(800, 600, P3D);

  // setup the camera
  cam = new PeasyCam(this, 1500);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(5000);
  perspective(radians(25), (float)width / (float)height, .1, 5000);
  
  xform.rotate(radians(45),0,1,0);
  
  ///////////////////////////////////////////////////////////
  // setup for picking
  pickHelpers.init(this);}

void draw()
{
  background(0);

  coordSys(100);

  // draw sphere
  fill(255);
  stroke(100);
  pushMatrix();
    applyMatrix(xform);
    translate(boxCenter.x,boxCenter.y,boxCenter.z);
    box(boxW,boxH,boxD);
  popMatrix();

  // check if the ray hits the triangle
  PVector hit1 = new PVector();
  PVector hit2 = new PVector();
                   
  if(boxIntersection(xform,
                     pRay,
                     pRayDir,
                     boxCenter,
                     boxW,
                     boxH,
                     boxD,
                     hit1,hit2) > 0)
  {
    strokeWeight(10);
    stroke(255, 0, 0);
    point(hit1.x, hit1.y, hit1.z);
    stroke(105, 0, 0);
    point(hit2.x, hit2.y, hit2.z);
    strokeWeight(1);
  }
  
}

void mousePressed()
{
  if(keyPressed == true && key == CODED && keyCode == SHIFT &&  mouseButton == LEFT)
  {
    PVector p2 = new PVector();
    
     // get the current hit ray
    pickHelpers.getHitRay(mouseX,mouseY,
                          pRay,p2);
    pRayDir = PVector.sub(p2,pRay);
    
    println("--");
  }
}

